program main
    implicit none
    character, dimension(10,10) :: labyrinth = reshape( [ &
        &"X","X","X","X","X","X","X","X","X","X", &
        &"X"," "," "," "," ","X"," "," "," "," ", &
        &"X","X","X","X"," ","X","X"," ","X","X", &
        &"X"," "," "," "," ","X","X"," ","X","X", &
        &"X"," ","X","X"," ","X","X"," "," ","X", &
        &"X"," "," ","X"," ","X","X"," ","X","X", &
        &"X","X","X","X"," "," "," "," "," ","X", &
        &"X","X"," ","X"," ","X"," ","X"," ","X", &
        &"X"," "," "," "," ","X"," ","X"," ","X", &
        &"X","X","X","X","X","X","X","X","X","X" &
    & ], [10,10], order=[2,1])
    logical :: end
    call backtracking(labyrinth,2,2, end)

contains
    recursive subroutine backtracking(labyrinth, x, y, end)
        character, dimension(:,:), intent(inout) :: labyrinth
        integer, intent(in) :: x,y
        logical, intent(out) :: end
        integer, dimension(4) :: xdir = [1,0,-1,0]
        integer, dimension(4) :: ydir = [0,-1,0,1]
        integer :: i 
        if (labyrinth(y,x)==" ") then
            labyrinth(y,x) = "."
            end = x==1 .or. x==size(labyrinth,2) .or. y==1 .or. y==size(labyrinth,1)
            if (end) then 
                call printLabyrinth(labyrinth)
            else
                do i = 1,4 
                    call backtracking(labyrinth,x+xdir(i),y+ydir(i),end)
                    if (end) exit
                end do 
                labyrinth(y,x) = " "
            end if 
        end if 
    end subroutine backtracking
    
    subroutine printLabyrinth(labyrinth)
        character, dimension(:,:), intent(inout) :: labyrinth
        integer :: i
        do i=1,size(labyrinth,1)
            write(*,*) expanded(labyrinth(i,:),up=.true.)
            write(*,*) expanded(labyrinth(i,:),up=.false.)
        end do
    end subroutine printLabyrinth
    elemental function expanded(char, up)
        character, intent(in) :: char
        character(3) :: expanded
        logical, intent(in) :: up
        if ( char=="." ) then
            if ( up ) then
                expanded = " . "
            else 
                expanded = "   "
            end if
        else 
            expanded = char//char//char
        end if
    end function expanded
end program main