!Function+Subroutine--------------------------------

    module FunctionsAndSubroutines
        implicit none
        
    contains

        function square(arg) 
            integer, intent(in) :: arg
            integer :: square

            square = arg*arg

        end function square

        recursive function factorial(n) result(res)
                integer, intent(in) :: n
                integer :: res
                
                if (n == 0) then
                    res = 1
                else
                    res = n * factorial(n - 1)
                end if
        end function factorial
        
        subroutine routine(arg1,  arg2)
            integer, intent(in) :: arg1
            real, intent(inout) ::  arg2
        
            arg2 = arg1*arg2
            
        end subroutine routine

        recursive subroutine print_numbers(n)
            integer, intent(in) :: n
            
            if (n > 1) then
                call print_numbers(n - 1)
            end if
            write(*,*) n
        end subroutine print_numbers

    end module FunctionsAndSubroutines

!Type declaration-----------------------------------

    module CustomDataTypeModule
        implicit none
        
        type :: Person
            character(len=50) :: name
            integer :: age
            real :: height
        end type Person

        contains
        
    end module CustomDataTypeModule

!Interface---------------------------------------
    module Interface
        implicit none

        Interface generic_name 
            module procedure function1
        end interface

        Interface operator(<)
            module procedure function2
        end interface

        Interface assignment(=)
            module procedure function3
        end interface
        
        contains
        
    end module Interface

!Arrays------------------------------------------

    program ArrayExample
        implicit none
        
        integer, dimension(5) :: A 
        real, dimension(2,2):: B
        integer, dimension(:), allocatable:: C
        
        A=(/1,2,3,4,5/)
        A(1)=3


        allocate(C(5))
        C=A
        deallocate(C)


        
    end program ArrayExample

!IO----------------------------------------------

    program IO
        implicit none
        integer:: ios

        open(unit=30, file="text.txt", status="old", action="read", iostat=ios)
        if(ios/=0)write(*,*)"error"

        read(30,*)
        !...
        close(30)
    end program IO


    